# -*- rpm-spec -*-

# Default to skipping autoreconf.  Distros can change just this one line
# (or provide a command-line override) if they backport any patches that
# touch configure.ac or Makefile.am.
%{!?enable_autotools:%define enable_autotools 1}

# Plugin isn't ready for real world use yet - it needs
# a security audit at very least
%define _with_plugin %{?with_plugin:1}%{!?with_plugin:0}

%define with_gtk3 0
%if 0%{?fedora} >= 15
%define with_gtk3 1
%endif

%define with_spice 0
%if 0%{?fedora} >= 16
%define with_spice 1
%endif

%if 0%{?rhel} >= 6
%define with_spice 1
%endif

# spice-gtk is x86 x86_64 only currently:
%ifnarch %{ix86} x86_64
%define with_spice 0
%endif

Name: virt-viewer
Version: 0.5.2
Release: 18%{?dist}%{?extra_release}
Summary: Virtual Machine Viewer
Group: Applications/System
License: GPLv2+
URL: http://virt-manager.org/
Source0: http://virt-manager.org/download/sources/%{name}/%{name}-%{version}.tar.gz
Patch1: 0001-Notify-of-focus-state-when-a-client-connects.patch
Patch2: 0002-Make-sure-we-call-g_thread_init.patch
Patch3: 0003-Updated-translations.patch
Patch4: 0004-Do-not-crash-so-easily-when-given-invalid-uri.patch
Patch5: 0005-Fix-indentation.patch
Patch6: 0006-spice-implement-fullscreen-auto-conf.patch
Patch7: 0007-Display-correct-key-bindings-to-release-cursor.patch
Patch8: 0008-spice-remove-usage-of-deprecated-audio-api.patch
Patch9: 0009-spice-handle-switch-host-event.patch
Patch10: 0010-Don-t-leak-foreign-menu.patch
Patch11: 0011-Do-not-try-to-unref-NULL-menu.patch
Patch12: 0012-Notify-focus-state-when-the-foreign-menu-title-is-se.patch
Patch13: 0013-Do-not-warn-if-the-display-is-shown-and-not-ready.patch
Patch14: 0014-Add-support-for-the-SPICE-properties-disable-effects.patch
Patch15: 0015-Propagate-USB-redirection-controller-messages.patch
Patch16: 0016-Fix-close-of-VNC-displays.patch
Patch17: 0017-Fix-manpage-to-s-fullscreen-full-screen.patch
Patch18: 0018-Add-manpage-docs-for-the-attach-option.patch
Patch19: 0019-Fix-automatic-usb-redir-through-controller.patch
Patch20: 0020-Fix-scaling-of-window-to-avoid-integer-truncation.patch
Patch21: 0021-Add-support-for-raw-IPv6-addresses-in-VNC-libvirt-UR.patch
Patch22: 0022-Set-the-remote-viewer-binary-application-name.patch
Patch23: 0023-Add-debugging-when-performing-fullscreen-auto-config.patch
Patch24: 0024-Change-OK-button-to-Close-button-in-USB-device-selec.patch
Patch25: 0025-Ensure-windows-are-destroyed-when-display-closes.patch
Patch26: 0026-Avoid-race-condition-when-disposing-of-app.patch
Patch27: 0027-spice-use-weak-references-to-display-channel.patch
Patch28: 0028-Use-real-binary-name-in-help-message.patch
Patch29: 0029-remote-viewer-add-a-simple-connection-dialog.patch
Patch30: 0030-Allow-user-to-set-a-window-title-for-remote-viewer.patch
Patch31: 0031-Fix-check-for-IPv6-any-address.patch
Patch32: 0032-Append-n-to-message-in-virt_viewer_app_trace.patch
Patch33: 0033-Propagate-SEND_CAD-from-controller-to-SpiceSession.patch
Patch34: 0034-Don-t-leak-SPICE-ticket.patch
Patch35: 0035-Disable-menu-items-that-would-fail-when-there-is-no-.patch
Patch36: 0036-Fix-various-memory-leaks.patch
Patch37: 0037-spice-improve-fullscreen-auto-conf.patch
Patch38: 0038-spice-disconnect-signal-handlers-when-either-object-.patch
Patch39: 0039-build-generate-enums-type-boilerplate.patch
Patch40: 0040-Destroy-dialog-immediately-after-run.patch
Patch41: 0041-Turn-display-show-hint-into-flags-type.patch
Patch42: 0042-Run-time-check-values-before-doing-bad-computation.patch
Patch43: 0043-Mark-a-menu-string-as-translatable.patch
Patch44: 0044-Rebuild-display-menu-when-a-window-is-added-or-remov.patch
Patch45: 0045-Use-virt_viewer_connect_object-for-display.patch
Patch46: 0046-Add-a-DISABLED-display-hint.patch
Patch47: 0047-Prevent-from-adding-the-same-display-several-time-in.patch
Patch48: 0048-Number-display-starting-from-1.patch
Patch49: 0049-Use-SpiceDisplay-ready-property-instead-of-channel-m.patch
Patch50: 0050-Bump-glib-2.22-add-compat-file.patch
Patch51: 0051-Hook-up-handling-of-Monitors.patch
Patch52: 0052-Add-virt_viewer_window_get_display.patch
Patch53: 0053-Add-VirtViewerDisplay-selectable-property.patch
Patch54: 0054-spice-factor-out-main-channel-lookup-code.patch
Patch55: 0055-Make-the-display-submenu-insensitive-if-display-can-.patch
Patch56: 0056-Add-VirtViewerSession-session-display-updated.patch
Patch57: 0057-Simplify-display-flag-handling.patch
Patch58: 0058-vnc-when-session-is-disconnected-make-the-display-as.patch
Patch59: 0059-Make-status-widget-visible-immediately.patch
Patch60: 0060-Show-status-page-by-default-if-display-not-ready.patch
Patch61: 0061-Fix-recent-spice-controller-regression-add-error-mes.patch
Patch62: 0062-Don-t-free-SPICE-ticket-twice.patch
Patch63: 0063-Do-not-resize-window-to-minimum-when-toggling-auto-r.patch
Patch64: 0064-Minor-simplification-optimization-of-VirtViewerDispl.patch
Patch65: 0065-spice-avoid-rounding-issues-when-scaling-up-display.patch
Patch66: 0066-spice-only-autoresize-once-with-screen-size-in-fulls.patch
Patch67: 0067-Disable-mnemonics-via-gtk-enable-mnemonics-settings.patch
Patch68: 0068-Set-a-default-dir-name-for-screenshots.patch
Patch69: 0069-Allow-to-save-to-other-formats-than-png.patch
Patch70: 0070-Make-sure-png-screenshots-have-a-.png-extensions.patch
Patch71: 0071-Use-monitor-geometry-not-screen-size.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires: openssh-clients
Requires(post):   %{_sbindir}/update-alternatives
Requires(postun): %{_sbindir}/update-alternatives

%if 0%{?enable_autotools}
BuildRequires: autoconf
BuildRequires: automake
BuildRequires: gettext-devel
BuildRequires: libtool
%endif

%if %{with_gtk3}
BuildRequires: gtk3-devel >= 3.0.0
%else
BuildRequires: gtk2-devel >= 2.12.0
%endif
BuildRequires: libvirt-devel >= 0.9.7
BuildRequires: libxml2-devel
%if %{with_gtk3}
BuildRequires: gtk-vnc2-devel >= 0.4.0
%else
BuildRequires: gtk-vnc-devel >= 0.3.8
%endif
%if %{with_spice}
%if %{with_gtk3}
BuildRequires: spice-gtk3-devel >= 0.11
%else
BuildRequires: spice-gtk-devel >= 0.11
%endif
BuildRequires: spice-protocol >= 0.10.1
%endif
BuildRequires: /usr/bin/pod2man
BuildRequires: intltool
%if %{_with_plugin}
%if 0%{?fedora} > 8
BuildRequires: xulrunner-devel
%else
BuildRequires: firefox-devel
%endif
%endif

%description
Virtual Machine Viewer provides a graphical console client for connecting
to virtual machines. It uses the GTK-VNC or SPICE-GTK widgets to provide
the display, and libvirt for looking up VNC/SPICE server details.

%if %{_with_plugin}
%package plugin
Summary: Mozilla plugin for the gtk-vnc library
Group: Development/Libraries
Requires: %{name} = %{version}

%description plugin
Virtual Machine Viewer provides a graphical console client for connecting
to virtual machines. It uses the GTK-VNC or SPICE-GTK widgets to provide
the display, and libvirt for looking up VNC/SPICE server details.

This package provides a web browser plugin for Mozilla compatible
browsers.
%endif

%prep
%setup -q
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1
%patch26 -p1
%patch27 -p1
%patch28 -p1
%patch29 -p1
%patch30 -p1
%patch31 -p1
%patch32 -p1
%patch33 -p1
%patch34 -p1
%patch35 -p1
%patch36 -p1
%patch37 -p1
%patch38 -p1
%patch39 -p1
%patch40 -p1
%patch41 -p1
%patch42 -p1
%patch43 -p1
%patch44 -p1
%patch45 -p1
%patch46 -p1
%patch47 -p1
%patch48 -p1
%patch49 -p1
%patch50 -p1
%patch51 -p1
%patch52 -p1
%patch53 -p1
%patch54 -p1
%patch55 -p1
%patch56 -p1
%patch57 -p1
%patch58 -p1
%patch59 -p1
%patch60 -p1
%patch61 -p1
%patch62 -p1
%patch63 -p1
%patch64 -p1
%patch65 -p1
%patch66 -p1
%patch67 -p1
%patch68 -p1
%patch69 -p1
%patch70 -p1
%patch71 -p1

%build

%if 0%{?enable_autotools}
autoreconf -if
%endif

%if %{_with_plugin}
%define plugin_arg --enable-plugin
%else
%define plugin_arg --disable-plugin
%endif

%if %{with_spice}
%define spice_arg --with-spice-gtk
%else
%define spice_arg --without-spice-gtk
%endif

%if %{with_gtk3}
%define gtk_arg --with-gtk=3.0
%else
%define gtk_arg --with-gtk=2.0
%endif

%configure %{spice_arg} %{plugin_arg} %{gtk_arg}
%__make %{?_smp_mflags}


%install
rm -rf $RPM_BUILD_ROOT
%__make install  DESTDIR=$RPM_BUILD_ROOT
mkdir -p %{buildroot}%{_libexecdir}
touch %{buildroot}%{_libexecdir}/spice-xpi-client
install -m 0755 data/spice-xpi-client-remote-viewer %{buildroot}%{_libexecdir}/
%if %{_with_plugin}
rm -f %{buildroot}%{_libdir}/mozilla/plugins/%{name}-plugin.a
rm -f %{buildroot}%{_libdir}/mozilla/plugins/%{name}-plugin.la
%endif
%find_lang %{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post
/bin/touch --no-create %{_datadir}/icons/hicolor &>/dev/null || :
%{_sbindir}/update-alternatives --install %{_libexecdir}/spice-xpi-client \
  spice-xpi-client %{_libexecdir}/spice-xpi-client-remote-viewer 25

%postun
if [ $1 -eq 0 ] ; then
  /bin/touch --no-create %{_datadir}/icons/hicolor &>/dev/null
  /usr/bin/gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
  %{_sbindir}/update-alternatives --remove spice-xpi-client %{_libexecdir}/spice-xpi-client-remote-viewer
fi

%posttrans
/usr/bin/gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :

%files -f %{name}.lang
%defattr(-,root,root,-)
%doc README COPYING AUTHORS ChangeLog NEWS
%{_bindir}/%{name}
%{_bindir}/remote-viewer
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/ui/
%{_datadir}/%{name}/ui/virt-viewer.xml
%{_datadir}/%{name}/ui/virt-viewer-auth.xml
%{_datadir}/%{name}/ui/virt-viewer-about.xml
%{_datadir}/icons/hicolor/*/apps/*
%ghost %{_libexecdir}/spice-xpi-client
%{_libexecdir}/spice-xpi-client-remote-viewer
%{_mandir}/man1/virt-viewer.1*
%{_mandir}/man1/remote-viewer.1*

%if %{_with_plugin}
%files plugin
%defattr(-, root, root)
%{_libdir}/mozilla/plugins/%{name}-plugin.so
%endif

%changelog
* Tue Dec 11 2012 Daniel P. Berrange <berrange@redhat.com> - 0.5.2-18
- Fix resolution when switching to fullscreen (rhbz #881020)
- Ensure correct file extension on screenshots (rhbz #875126)

* Tue Dec  4 2012 Daniel P. Berrange <berrange@redhat.com> - 0.5.2-17
- Fix handling of AltGr+V in non-us keyboard layouts (rhbz #860669)

* Wed Oct 24 2012 Daniel P. Berrange <berrange@redhat.com> - 0.5.2-16
- Don't resize to 50x50 when toggling autoresize (rhbz #856610)
- Allow zooming beyond normal size (rhbz #856678)
- Allow changing resolution when in fullsreen (rhbz #864929)

* Wed Oct 24 2012 Daniel P. Berrange <berrange@redhat.com> - 0.5.2-15
- Fix crash starting remote-viewer from XPI plugin (rhbz #867459)
- Fix crash connecting with wrong spice password (rhbz #867248)

* Mon Oct 15 2012 Daniel P. Berrange <berrange@redhat.com> - 0.5.2-14
- Add support for multi-monitors per QXL device (rhbz #842305)

* Fri Oct 12 2012 Daniel P. Berrange <berrange@redhat.com> - 0.5.2-13
- Propagate ctrl-alt-del from spice controller (rhbz #865793)

* Fri Oct 12 2012 Daniel P. Berrange <berrange@redhat.com> - 0.5.2-12
- Use real binary name in help message (rhbz #814150)
- Correctly detect IPv6 any address (rhbz #832121)
- Add --title option to remote-viewer (rhbz #828339)
- Add newline at end of verbose info output (rhbz #822794)

* Mon Sep 24 2012 Daniel P. Berrange <berrange@redhat.com> - 0.5.2-11
- Rebuild for change in spice-gtk soname (rhbz #854318)

* Mon Sep 24 2012 Daniel P. Berrange <berrange@redhat.com> - 0.5.2-10
- Rebuild for change in spice-gtk soname (rhbz #854318)

* Mon May 21 2012 Daniel P. Berrange <berrange@redhat.com> - 0.5.2-9
- Use weak references on channel to ensure prompt finalization (rhbz #822683)

* Tue May  8 2012 Daniel P. Berrange <berrange@redhat.com> - 0.5.2-8
- Fix race condition in window dispose (rhbz #819436)

* Fri May  4 2012 Daniel P. Berrange <berrange@redhat.com> - 0.5.2-7
- Change to Ok to Close in USB redirection (rhbz #816280)
- Fix close of windows on guest shutdown (rhbz #816550)

* Mon Apr 23 2012 Daniel P. Berrange <berrange@redhat.com> - 0.5.2-6
- Fix scaling of windows on i386 arch (rhbz #810544)
- Support raw IPv6 addresses in URIs (rhbz #813375)
- Set remote-viewer application name (rhbz #814043)

* Tue Apr 17 2012 Daniel P. Berrange <berrange@redhat.com> - 0.5.2-5
- Raise priority of spice-xpi-client alternative to 25 (rhbz #813303)
- Add missing docs for --attach parameter (rhbz #811191)
- Fix typos in docs for --full-screen parameter (rhbz #811131)
- Fix usbredirect property usage (rhbz #807298)

* Wed Apr  4 2012 Daniel P. Berrange <berrange@redhat.com> - 0.5.2-4
- Fix close of VNC displays (rhbz #802673)
- Add usbredirect properties (rhbz #807298)
- Add properties to disable desktop effects (rhbz #808986)

* Wed Mar 21 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5.2-3
- Add --full-screen=auto-conf to remote-viewer (rhbz #803297)
- Correctly handle switch-host Spice migration (rhbz #802574)
- Fix USB auto-share doesn't work in full-screen (rhbz #803834)

* Wed Mar 14 2012 Daniel P. Berrange <berrange@redhat.com> - 0.5.2-2
- Set initial focus state & initialize threads (rhbz #803077)
- Refresh translations (rhbz #797015)

* Fri Mar  9 2012 Daniel P. Berrange <berrange@redhat.com> - 0.5.2-1
- Update to 0.5.2 release
- Fix connect to password protected SPICE displays over SSH (rhbz #749759)
- Add SPICE smartcard support (rhbz #789090)
- Honour hot key configuration from SPICE controller (rhbz #795437)
- Refresh translations (rhbz #797015)
- Fix crash reconnecting to SPICE after guest restart (rhbz #797082)
- Add support for foreign menus with SPICE (rhbz #799038)

* Tue Feb 17 2012 Daniel P. Berrange <berrange@redhat.com> - 0.5.1-1
- Update to 0.5.1 release (rhbz #784920, #749723, #784922)

* Tue Feb 14 2012 Daniel P. Berrange <berrange@redhat.com> - 0.5.0-1
- Update to 0.5.0 release (rhbz #784920, #749723, #784922)

* Tue Jan 31 2012 Daniel P. Berrange <berrange@redhat.com> - 0.4.1-9
- Rebuild for spice-gtk soname change (rhbz #784536)

* Wed Oct 12 2011 Daniel P. Berrange <berrange@redhat.com> - 0.4.1-7
- Fix initial window title when waiting for guest (rhbz #744374)
- Fix detection of SPICE pointer grabs to update title (rhbz #744377)
- Fix incorrect key sequence for C-A-F9/10/11/12 (rhbz #744370)

* Wed Sep 28 2011 Daniel P. Berrange <berrange@redhat.com> - 0.4.1-6
- Fix crash when using UNIX domain sockets (rhbz #740724)

* Mon Sep 19 2011 Daniel P. Berrange <berrange@redhat.com> - 0.4.1-5
- Fix zoom level on non-primary monitors (rhbz #730901)
- Fix missing domain name in window title (rhbz #739007)
- Don't crash if URI parsing fails (rhbz #734769)
- Fix direct connection to VMs using a wildcard address (rhbz #730911)

* Thu Aug 18 2011 Daniel P. Berrange <berrange@redhat.com> - 0.4.1-4
- Fix initial zoom level setting (rhbz #730901)
- Fix potential deadlock in event callback (rhbz #731132)

* Sun Aug 14 2011 Daniel P. Berrange <berrange@redhat.com> - 0.4.1-3
- More fixes for ssh port tunnelling (rhbz #730346)

* Fri Aug 12 2011 Daniel P. Berrange <berrange@redhat.com> - 0.4.1-2
- Fix ssh port tunnelling (rhbz #730346)

* Thu Aug  4 2011 Daniel P. Berrange <berrange@redhat.com> - 0.4.1-1
- Update to 0.4.1 release for SPICE multihead (rhbz #680213)

* Mon Jul 25 2011 Daniel P. Berrange <berrange@redhat.com> - 0.4.0-2
- Enable SPICE in RHEL-6 (rhbz #680213)

* Tue Jul 12 2011 Daniel P. Berrange <berrange@redhat.com> - 0.4.0-1
- Update to 0.4.0 release (rhbz #680213, #680331)

* Thu Feb  3 2011 Daniel P. Berrange <berrange@redhat.com> - 0.2.1-3
- Add support for UNIX sockets (rhbz #651604)
- Fix wait for VMs based on UUID (rhbz #631667)

* Tue Jun  8 2010 Daniel P. Berrange <berrange@redhat.com> - 0.2.1-2
- Add translated po files for all available languages (rhbz #510231)

* Fri Jan 15 2010 Daniel P. Berrange <berrange@redhat.com> - 0.2.1-1
- Update to 0.2.1 release with i18n support (rhbz #510231)

* Fri Nov 13 2009 Dennis Gregorovic <dgregor@redhat.com> - 0.2.0-1.1
- Fix conditional for RHEL

* Wed Jul 29 2009 Daniel P. Berrange <berrange@redhat.com> - 0.2.0-1.fc12
- Update to 0.2.0 release

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.0.3-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu May  7 2009 Daniel P. Berrange <berrange@redhat.com> - 0.0.3-5.fc12
- Fix auth against libvirt (rhbz #499594)
- Fix confusion of VNC credentials (rhbz #499595)
- Correct keyboard grab handling (rhbz #499362)

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.0.3-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Mon Jul  7 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0.0.3-3.fc10
- fix conditional comparison
- remove file dep

* Wed Jun 25 2008 Daniel P. Berrange <berrange@redhat.com> - 0.0.3-2.fc10
- Rebuild for GNU TLS ABI bump

* Mon Mar 10 2008 Daniel P. Berrange <berrange@redhat.com> - 0.0.3-1.fc9
- Updated to 0.0.3 release

* Mon Feb 18 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 0.0.2-4
- Autorebuild for GCC 4.3

* Fri Jan 11 2008 Daniel P. Berrange <berrange@redhat.com> - 0.0.2-3.fc9
- Set domain name as window title
- Hide input for passwd fields during auth

* Mon Oct 15 2007 Daniel P. Berrange <berrange@redhat.com> - 0.0.2-2.fc8
- Change TLS x509 credential name to sync with libvirt

* Tue Aug 28 2007 Daniel P. Berrange <berrange@redhat.com> - 0.0.2-1.fc8
- Added support for remote console access

* Fri Aug 17 2007 Daniel P. Berrange <berrange@redhat.com> - 0.0.1-2.fc8
- Restrict built to x86 & ia64 because libvirt is only on those arches

* Wed Aug 15 2007 Daniel P. Berrange <berrange@redhat.com> - 0.0.1-1.fc8
- First release

